
/*
 * Box85 levels compressor
 * By Kaid [kaid@excite.fr]
*/

/* Size of buffer */
#define TAILLE_BUF 1024

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/stat.h>

/* Prototypes */
unsigned int Pack(char *source,char *destination, unsigned int taille);
unsigned int LitFichier(char *fichier,char *buf_dest,unsigned int buf_taille);
void EcritFichier(char *fichier,char *buf_src,unsigned int buf_taille);
void GenErreur(char *message,unsigned char code);


main(int argc, char **argv)
{
 char *source,*destination,*dest_sav;
 char *nomfich;
 unsigned int taille,tailleComp;


 /* Lecture du fichier */

 if ((source=malloc(TAILLE_BUF))==NULL)
  GenErreur("Memory allocation error",5);

 nomfich=strdup(argv[1]);
 nomfich=strcat(nomfich,".OBJ");
 taille=LitFichier(nomfich,source,TAILLE_BUF);



 if ((destination=malloc(TAILLE_BUF))==NULL)
  GenErreur("Memory allocation error",5);
 dest_sav=destination;

 /* Compression des niveaux */
 tailleComp=Pack(source,destination,taille);

 /* Ecriture du fichier */
 nomfich=strdup(argv[1]);
 nomfich=strcat(nomfich,".PAK");
 EcritFichier(nomfich,dest_sav,tailleComp);

}

/* Compresse la source */
unsigned int Pack(char *source,char *destination, unsigned int taille)
{
 char *source_sav=source;
 char *destination_sav=destination;
 unsigned char octet;
 unsigned int i;

 /* Tant que l'on a pas compress toute la source */
 while((source-source_sav)<taille)
 {

  /* On copie d'abord le nombre de caisses et la position initiale du mec */
  *destination++=*source++;
  *destination++=*source++;
  
  /* On compresse ensuite le niveau */
  for(i=0;i<28;i++)
  {
   octet =*source++;
   octet+=*source++ << 2;
   octet+=*source++ << 4;
   octet+=*source++ << 6;

   *destination++=octet;
  }
 }

/* On retourne la taille compresse */
return (destination-destination_sav);
}



/* Lit un fichier */
unsigned int LitFichier(char *fichier,char *buf_dest,unsigned int buf_taille)
{
  unsigned int Taille;
  int handle;

  if ((handle=open(fichier,O_RDONLY|O_BINARY))==-1)
    GenErreur("Error on file opening",1);

 /* Lecture du fichier */
 Taille=read(handle,buf_dest,buf_taille);

 if (Taille==-1)
   GenErreur("Error on file reading",1);

 close(handle);

 return Taille;
}

/* Cre un fichier */
void EcritFichier(char *fichier,char *buf_src,unsigned int buf_taille)
{
  int handle;

  if ((handle=creat(fichier,S_IRUSR|S_IWUSR))==-1)
    GenErreur("Error on file creating",1);

 /* Ecriture du fichier */
 if (write(handle,buf_src,buf_taille)==-1)
  GenErreur("Error on file writing",1);

 close(handle);
}

/* Gnre une erreur */
void GenErreur(char *message,unsigned char code)
{
   printf("%s.\n",message);
   exit(code);
}

